/* int^fbNIntDequeuei\[Xj*/

#include <stdio.h>
#include <stdlib.h>
#include "IntDequeue.h"

/*--- L[̏ ---*/
int Initialize(IntDequeue *q, int max)
{
	q->num = q->front = q->rear = 0;
	if ((q->que = calloc(max, sizeof(int))) == NULL) {
		q->max = 0;								/* z̊mۂɎs */
		return -1;
	}
	q->max = max;
	return 0;
}

/*--- L[̐擪Ƀf[^GL[ ---*/
int EnqueFront(IntDequeue *q, int x)
{
	if (q->num >= q->max)
		return -1;							/* L[͖t */
	else {
		q->num++;
		if (--q->front < 0)
			q->front = q->max - 1;
		q->que[q->front] = x;
		return 0;
	}
}

/*--- L[̖Ƀf[^GL[ ---*/
int EnqueRear(IntDequeue *q, int x)
{
	if (q->num >= q->max)
		return -1;							/* L[͖t */
	else {
		q->num++;
		q->que[q->rear++] = x;
		if (q->rear == q->max)
			q->rear = 0;
		return 0;
	}
}

/*--- L[̐擪f[^fL[ ---*/
int DequeFront(IntDequeue *q, int *x)
{
	if (q->num <= 0)						/* L[͋ */
		return -1;
	else {
		q->num--;
		*x = q->que[q->front++];
		if (q->front == q->max)
			q->front = 0;
		return 0;
	}
}

/*--- L[̖f[^fL[ ---*/
int DequeRear(IntDequeue *q, int *x)
{
	if (q->num <= 0)						/* L[͋ */
		return -1;
	else {
		q->num--;
		if (--q->rear < 0)
			q->rear = q->max - 1;
		*x = q->que[q->rear];
		return 0;
	}
}

/*--- L[̐擪f[^s[N ---*/
int PeekFront(const IntDequeue *q, int *x)
{
	if (q->num <= 0)							/* L[͋ */
		return -1;
	*x = q->que[q->front];
	return 0;
}

/*--- L[̖f[^s[N ---*/
int PeekRear(const IntDequeue *q, int *x)
{
	if (q->num <= 0)							/* L[͋ */
		return -1;
	*x = q->que[q->rear];
	return 0;
}

/*--- Sf[^폜 ---*/
void Clear(IntDequeue *q)
{
	q->num = q->front = q->rear = 0;
}

/*--- L[̗e ---*/
int Capacity(const IntDequeue *q)
{
	return q->max;
}

/*--- L[ɒ~Ăf[^ ---*/
int Size(const IntDequeue *q)
{
	return q->num;
}

/*--- L[͋ ---*/
int IsEmpty(const IntDequeue *q)
{
	return q->num <= 0;
}

/*--- L[͖t ---*/
int IsFull(const IntDequeue *q)
{
	return q->num >= q->max;
}

/*--- L[̒T ---*/
int Search(const IntDequeue *q, int x)
{
	int i, idx;

	for (i = 0; i < q->num; i++) {
		if (q->que[idx = (i + q->front) % q->max] == x)
			return idx;		/* T */
	}
	return -1;				/* Ts */
}

/*--- L[̒Ti_IYԋpj---*/
int Search2(const IntDequeue *q, int x)
{
	int i;

	for (i = 0; i < q->num; i++) {
		if (q->que[(i + q->front) % q->max] == x)
			return i;		/* T */
	}
	return -1;				/* Ts */
}

/*--- Sf[^̕\ ---*/
void Print(const IntDequeue *q)
{
	int i;

	for (i = 0; i < q->num; i++)
		printf("%d ", q->que[(i + q->front) % q->max]);
	putchar('\n');
}

/*--- L[̌n ---*/
void Terminate(IntDequeue *q)
{
	if (q->que != NULL)
		free(q->que);							/* z */
	q->max = q->num = q->front = q->rear = 0;
}
